diff --git a/test/integration/run_review_test.rb b/test/integration/run_review_test.rb
index 80ef099..fd84060 100644
--- a/test/integration/run_review_test.rb
+++ b/test/integration/run_review_test.rb
@@ -1310,7 +1310,7 @@ class RunReviewTest < Minitest::Test
               status: :ok, escalations_path: esc, error_message: nil, tampered_files: [], limit_text: nil
             )
           }) do
-            with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+            with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_spawn_kwargs|
               flunk "ad-hoc review should not run fix by default with accepted=#{accepted.inspect}"
             }) do
               capture_io { Hive::Commands::Run.new(folder).call }
@@ -1341,7 +1341,7 @@ class RunReviewTest < Minitest::Test
         Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
 
         accepted_seen = nil
-        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_spawn_kwargs|
           accepted_seen = accepted
           { status: :ok }
         }) do
@@ -2325,7 +2325,7 @@ class RunReviewTest < Minitest::Test
         Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
 
         accepted_seen = nil
-        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_spawn_kwargs|
           accepted_seen = accepted
           { status: :error, error_message: "fix failed" }
         }) do
@@ -2352,7 +2352,7 @@ class RunReviewTest < Minitest::Test
         Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
 
         accepted_seen = nil
-        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_spawn_kwargs|
           accepted_seen = accepted
           {
             status: :error,
diff --git a/test/unit/claude_launcher_test.rb b/test/unit/claude_launcher_test.rb
index 1d6b258..0b67fe5 100644
--- a/test/unit/claude_launcher_test.rb
+++ b/test/unit/claude_launcher_test.rb
@@ -701,6 +701,39 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  # Plumbing parity for the tolerant-completion seam (U2): both spawn
+  # entrypoints must forward completion_evidence into ClaudeLauncher so
+  # every :exit_code_only consumer can opt in without reaching around
+  # Base.
+  def test_spawn_helpers_forward_completion_evidence_to_launcher
+    with_tmp_task do |task|
+      captured = nil
+      original = Hive::ClaudeLauncher.method(:launch!)
+      capture_unbound_method(:launch!, original) do
+        Hive::ClaudeLauncher.define_singleton_method(:launch!) do |**kwargs|
+          captured = kwargs
+          { status: :ok }
+        end
+
+        evidence = ->(_probe) { { artifacts: "a", commit_evidence: "c" } }
+        Hive::Stages::Base.spawn_claude_with_tmux_marker!(
+          task,
+          { "claude" => { "mode" => "tmux" } },
+          prompt: "prompt",
+          max_budget_usd: 1,
+          timeout_sec: 1,
+          log_label: "test",
+          session_name: "hive-test-evidence",
+          status_mode: :exit_code_only,
+          completion_evidence: evidence
+        )
+      end
+
+      assert_equal :exit_code_only, captured.fetch(:status_mode)
+      assert_respond_to captured.fetch(:completion_evidence), :call
+    end
+  end
+
   def test_spawn_claude_with_tmux_marker_records_marker
     with_tmp_task do |task|
       original = Hive::ClaudeLauncher.method(:launch!)
@@ -1249,6 +1282,204 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  # --- Tolerant completion fallback (2026-06-29) ---------------------------
+  # When .done never lands but claude demonstrably exited cleanly AND the
+  # caller's evidence proves real completion, the deadline branch returns
+  # :ok with fallback metadata + one WARN audit event instead of the
+  # stop-hook timeout. Every strict failure below stays byte-for-byte.
+
+  def test_wait_for_done_signal_timeout_without_evidence_is_unchanged
+    with_tmp_task do |task|
+      [ nil, false ].each do |evidence|
+        result = Hive::ClaudeLauncher.wait_for_done_signal(
+          task, nil, 0, "ci", evidence
+        )
+
+        assert_equal :timeout, result.fetch(:status),
+                     "evidence=#{evidence.inspect} must keep legacy strict behavior"
+        assert_equal "claude stop hook did not signal completion", result.fetch(:error_message)
+        refute result.key?(:fallback)
+      end
+    end
+  end
+
+  def test_fallback_converts_clean_exit_with_evidence_to_ok_and_emits_event
+    with_tmp_task(stage: "6-review") do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      runner = Struct.new(:name, :tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new("hive-6-review-fix-pass01-task", "work finished cleanly")
+      calls = []
+      evidence = ->(_probe) {
+        calls << _probe
+        { phase: :fix, pass: 1,
+          artifacts: "reviewer files ok; escalations ok",
+          commit_evidence: "HEAD moved abc1234 -> deadbeef" }
+      }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "review-fix-pass01", evidence)
+
+      assert_equal :ok, result.fetch(:status)
+      assert_equal "review-fix-pass01", result.fetch(:log_label)
+      fallback = result.fetch(:fallback)
+      assert_equal Hive::ClaudeLauncher::FALLBACK_MISSING_SIGNAL_REASON, fallback.fetch(:reason)
+      assert_equal "0", fallback.fetch(:exit_code)
+      assert_match(/HEAD moved/, fallback.fetch(:evidence))
+
+      events = File.readlines(File.join(task.folder, "events.jsonl"), chomp: true)
+                   .map { |line| JSON.parse(line) }
+      fallback_events = events.select { |e| e["event_type"] == "claude_completion_fallback" }
+      assert_equal 1, fallback_events.size, "exactly one WARN event per fallback"
+      message = fallback_events.first.fetch("message")
+      %w[phase= pass= expected= artifacts= commit_evidence= slug=].each do |prefix|
+        assert_includes message, prefix
+      end
+      assert_includes message, "pass=01"
+      # The evidence probe receives the launcher-captured pane tail so
+      # providers can apply their own final-message predicates.
+      assert_equal({ pane_tail: "work finished cleanly" }, calls.fetch(0))
+    end
+  end
+
+  def test_fallback_requires_claude_exit_code_file
+    with_tmp_task do |task|
+      evidence = ->(_probe) { { artifacts: "x", commit_evidence: "y" } }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci", evidence)
+
+      assert_equal :timeout, result.fetch(:status)
+      refute result.key?(:fallback)
+    end
+  end
+
+  def test_fallback_strict_on_nonzero_exit_code
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "1\n")
+      evidence = ->(_probe) { { artifacts: "x", commit_evidence: "y" } }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci", evidence)
+
+      assert_equal :timeout, result.fetch(:status),
+                   "exit!=0 must stay strict even when evidence claims completion"
+      refute result.key?(:fallback)
+    end
+  end
+
+  def test_fallback_strict_when_exit_code_file_empty_or_garbage
+    with_tmp_task do |task|
+      FileUtils.touch(Hive::ClaudeLauncher.exit_code_path(task))
+      evidence = ->(_probe) { { artifacts: "x", commit_evidence: "y" } }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci", evidence)
+
+      assert_equal :timeout, result.fetch(:status),
+                   "an empty exit-code file reads as unknown — unknown is strict"
+      refute result.key?(:fallback)
+    end
+  end
+
+  def test_fallback_limit_wall_wins_over_evidence
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      limit_menu = pane_fixture("limit_menu_live.txt")
+      runner = Struct.new(:tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new(limit_menu)
+      evidence = ->(_probe) { { artifacts: "x", commit_evidence: "y" } }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "ci", evidence)
+
+      assert_equal :error, result.fetch(:status),
+                   "a live provider-limit wall must win over the fallback"
+      assert_equal "❯ 1. Stop and wait for limit to reset", result.fetch(:limit_text)
+    end
+  end
+
+  def test_fallback_strict_with_error_status_in_result_json
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "failed"))
+      evidence = ->(_probe) { { artifacts: "x", commit_evidence: "y" } }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci", evidence)
+
+      assert_equal :timeout, result.fetch(:status),
+                   "hook-reported non-ok status must stay strict even on exit 0"
+      refute result.key?(:fallback)
+    end
+  end
+
+  def test_fallback_tolerates_ok_status_in_result_json
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+      evidence = ->(_probe) { { artifacts: "ok" } }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci", evidence)
+
+      assert_equal :ok, result.fetch(:status)
+      assert result.key?(:fallback)
+    end
+  end
+
+  def test_fallback_trust_prompt_in_tail_stays_strict
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      runner = Struct.new(:tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new("Do you want to trust this folder? Yes, I trust this folder")
+      evidence = ->(_probe) { { artifacts: "x", commit_evidence: "y" } }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "ci", evidence)
+
+      assert_equal :timeout, result.fetch(:status),
+                   "a stalled trust prompt must never be suppressed as completion"
+      refute result.key?(:fallback)
+    end
+  end
+
+  def test_fallback_treats_raising_evidence_as_no_evidence
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      evidence = ->(_probe) { raise ArgumentError, "boom" }
+
+      _out, err = capture_io do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci", evidence)
+
+        assert_equal :timeout, result.fetch(:status),
+                     "a raising evidence provider must fail strictly"
+        refute result.key?(:fallback)
+      end
+
+      assert_match(/completion_evidence callback raised/, err)
+      refute File.exist?(File.join(task.folder, "events.jsonl")),
+             "no fallback event may be emitted without proven completion"
+    end
+  end
+
+  def test_fallback_survives_event_emission_failure
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      # Simplest reliable emission failure: stub Events.emit itself.
+      original = Hive::Events.method(:emit)
+      Hive::Events.define_singleton_method(:emit) { raise Errno::EACCES, "disk full" }
+      begin
+        _out, err = capture_io do
+          result = Hive::ClaudeLauncher.wait_for_done_signal(
+            task, nil, 0, "ci", ->(_p) { { artifacts: "a" } }
+          )
+
+          assert_equal :ok, result.fetch(:status),
+                       "audit-event failure must not flip the spawn's envelope"
+          assert result.key?(:fallback)
+        end
+      ensure
+        Hive::Events.define_singleton_method(:emit, original)
+      end
+      assert_match(/could not emit claude_completion_fallback/, err)
+    end
+  end
+
   def test_waits_ignore_quoted_limit_menu_after_agent_moved_on
     quoted_pane = pane_fixture("limit_quoted_7456.txt")
 
@@ -1409,6 +1640,27 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  # claude_exit_code is a pre-spawn scratch file exactly like .done /
+  # result.json: reset_signal_files must clear it so a stale "0" from an
+  # earlier spawn can never leak into the next wait loop's clean-exit gate.
+  def test_reset_signal_files_and_cleanup_done_clear_claude_exit_code
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+
+      Hive::ClaudeLauncher.reset_signal_files(task)
+
+      refute File.exist?(Hive::ClaudeLauncher.exit_code_path(task))
+    end
+
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "1\n")
+
+      Hive::ClaudeLauncher.cleanup_done(task)
+
+      refute File.exist?(Hive::ClaudeLauncher.exit_code_path(task))
+    end
+  end
+
   def test_cleanup_scratch_ignores_directory_races
     with_tmp_task do |task|
       scratch = File.join(task.folder, ".claude", "settings.json")
diff --git a/test/unit/current_main_coverage_gap_test.rb b/test/unit/current_main_coverage_gap_test.rb
index 1c17f2a..3903892 100644
--- a/test/unit/current_main_coverage_gap_test.rb
+++ b/test/unit/current_main_coverage_gap_test.rb
@@ -15,6 +15,9 @@ require "hive/tui/update"
 require "hive/tui/views/idea_preview"
 require "hive/tui/views/red_status_detail"
 
+# Coverage-gap spot checks. Kept independent of real agents; spawn
+# replacement lambdas accept **extra kwargs so new plumbing (e.g.
+# completion_evidence) cannot wedge them.
 class CurrentMainCoverageGapTest < Minitest::Test
   include HiveTestHelper
 
@@ -362,7 +365,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
             with_replaced_singleton_method(Hive::Stages::Review, :reviewer_compare_ref, ->(_cfg, _ops) { "main" }) do
               with_replaced_singleton_method(Hive::Stages::Review, :git_head, ->(_path) { "head-before-fix" }) do
                 with_replaced_singleton_method(Hive::Stages::Review, :worktree_status, ->(_path) { status_checks.shift }) do
-                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:) { { status: :ok } }) do
+                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:, **_extra) { { status: :ok } }) do
                     with_replaced_singleton_method(Hive::Stages::Review, :auto_commit_fix_worktree, ->(_task, _cfg, _ctx, _accepted) {
                       { success: false, message: "git add -A failed: permission denied" }
                     }) do
@@ -405,7 +408,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
             with_replaced_singleton_method(Hive::Stages::Review, :reviewer_compare_ref, ->(_cfg, _ops) { "main" }) do
               with_replaced_singleton_method(Hive::Stages::Review, :git_head, ->(_path) { "head-before-fix" }) do
                 with_replaced_singleton_method(Hive::Stages::Review, :worktree_status, ->(_path) { status_checks.shift }) do
-                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:) { { status: :ok } }) do
+                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:, **_extra) { { status: :ok } }) do
                     result = Hive::Stages::Review.run!(task, { "review" => {} })
 
                     assert_equal :review_error, result[:status]
diff --git a/test/unit/interactive_wrapper_script_test.rb b/test/unit/interactive_wrapper_script_test.rb
index 6b9771b..442bc2f 100644
--- a/test/unit/interactive_wrapper_script_test.rb
+++ b/test/unit/interactive_wrapper_script_test.rb
@@ -177,6 +177,87 @@ class InteractiveWrapperScriptTest < Minitest::Test
     end
   end
 
+  # claude_exit_code instrumentation: the wrapper must persist claude's
+  # true exit status into ${HIVE_TASK_STAGE_DIR}/claude_exit_code right
+  # before exiting, so ClaudeLauncher can prove "agent ran to termination"
+  # independent of Stop-hook delivery.
+  def test_wrapper_writes_claude_exit_code_zero_on_clean_exit
+    with_tmp_dir do |dir|
+      stage_dir = File.join(dir, "stage")
+      FileUtils.mkdir_p(stage_dir)
+
+      _out, err, status = Open3.capture3(
+        { "HIVE_FAKE_CLAUDE_LOG_DIR" => File.join(dir, "logs"), "HIVE_TASK_STAGE_DIR" => stage_dir },
+        SCRIPT,
+        "--cwd", dir,
+        "--bin", FAKE_BIN
+      )
+
+      assert status.success?, err
+      assert_equal "0\n", File.read(File.join(stage_dir, "claude_exit_code"))
+    end
+  end
+
+  def test_wrapper_propagates_nonzero_claude_exit_status_and_records_it
+    with_tmp_dir do |dir|
+      stage_dir = File.join(dir, "stage")
+      FileUtils.mkdir_p(stage_dir)
+
+      _out, err, status = Open3.capture3(
+        {
+          "HIVE_FAKE_CLAUDE_LOG_DIR" => File.join(dir, "logs"),
+          "HIVE_TASK_STAGE_DIR" => stage_dir,
+          "HIVE_FAKE_CLAUDE_EXIT" => "3"
+        },
+        SCRIPT,
+        "--cwd", dir,
+        "--bin", FAKE_BIN
+      )
+
+      assert_equal 3, status.exitstatus,
+                   "the wrapper must forward claude's exit status verbatim"
+      assert_equal "3\n", File.read(File.join(stage_dir, "claude_exit_code"))
+    end
+  end
+
+  # A missing/unrunnable --bin previously surfaced as exec failure inside a
+  # replaced process; without exec it is an ordinary child failure (127) —
+  # and the file write must still happen so readers see a truthful nonzero
+  # instead of a stale/absent sentinel.
+  def test_wrapper_records_exit_status_even_when_bin_cannot_execute
+    with_tmp_dir do |dir|
+      stage_dir = File.join(dir, "stage")
+      FileUtils.mkdir_p(stage_dir)
+
+      _out, err, status = Open3.capture3(
+        { "HIVE_TASK_STAGE_DIR" => stage_dir },
+        SCRIPT,
+        "--cwd", dir,
+        "--bin", File.join(dir, "definitely-missing-claude-bin")
+      )
+
+      refute status.success?
+      refute_equal 0, File.read(File.join(stage_dir, "claude_exit_code")).to_i,
+                   "an unrunnable --bin must still record a truthful nonzero exit status"
+    end
+  end
+
+  # tmux-less invocations (unit tests, operator experiments) omit
+  # HIVE_TASK_STAGE_DIR entirely; the wrapper must not crash on the unset
+  # variable under `set -u`.
+  def test_wrapper_tolerates_missing_task_stage_dir
+    with_tmp_dir do |dir|
+      _out, err, status = Open3.capture3(
+        { "HIVE_TASK_STAGE_DIR" => nil },
+        SCRIPT,
+        "--cwd", dir,
+        "--bin", FAKE_BIN
+      )
+
+      assert status.success?, err
+    end
+  end
+
   private
 
   def argv_args(log)
diff --git a/test/unit/stages/execute_test.rb b/test/unit/stages/execute_test.rb
index af52b58..1bdbf37 100644
--- a/test/unit/stages/execute_test.rb
+++ b/test/unit/stages/execute_test.rb
@@ -339,7 +339,7 @@ class HiveStagesExecuteTest < Minitest::Test
 
   def with_fake_git_and_spawn(git, status: :ok, result: nil)
     with_replaced_singleton_method(Hive::GitOps, :new, ->(_path) { git }) do
-      with_replaced_singleton_method(Hive::Stages::Execute, :spawn_implementation, lambda { |_task, _cfg, _path|
+      with_replaced_singleton_method(Hive::Stages::Execute, :spawn_implementation, lambda { |_task, _cfg, _path, **_kwargs|
         result || { status: status }
       }) do
         yield
diff --git a/test/unit/stages/execute_tmux_envelope_test.rb b/test/unit/stages/execute_tmux_envelope_test.rb
index 7fa5ee0..12d01f1 100644
--- a/test/unit/stages/execute_tmux_envelope_test.rb
+++ b/test/unit/stages/execute_tmux_envelope_test.rb
@@ -92,6 +92,61 @@ class ExecuteTmuxEnvelopeTest < Minitest::Test
     end
   end
 
+  # --- Tolerant-completion seam (U4) -------------------------------------
+  # A clean-exited implementer whose Stop-hook signal was lost converts to a
+  # :ok envelope and run_pass's own guards decide the outcome. Driven through
+  # the REAL launcher gate (claude_exit_code + completion_evidence closure).
+  def test_tmux_execute_clean_exit_with_commit_completes_via_real_fallback_conversion
+    with_tmp_execute_task do |task, worktree_path|
+      cfg = base_cfg
+      write_worktree_pointer!(task, worktree_path)
+
+      with_spawn_marker_stub(lambda do |spawn_task, kwargs|
+        produce_commit!(worktree_path)
+        File.write(Hive::ClaudeLauncher.exit_code_path(spawn_task), "0\n")
+        converted = Hive::ClaudeLauncher.maybe_complete_without_done_signal(
+          spawn_task, nil, "implemented", kwargs[:log_label], kwargs.fetch(:completion_evidence)
+        )
+        converted || { status: :timeout,
+                       error_message: "claude stop hook did not signal completion" }
+      end) do
+        result = nil
+        _out = capture_io { result = Hive::Stages::Execute.run_pass(task, cfg, worktree_path) }
+
+        assert_equal :execute_complete, result[:status],
+                     "clean-exit + commit + evidence must complete the pass"
+        marker = Hive::Markers.current(task.state_file)
+        assert_equal :execute_complete, marker.name
+      end
+    end
+  end
+
+  def test_tmux_execute_hollow_run_still_lands_implementer_failed_strictly
+    with_tmp_execute_task do |task, worktree_path|
+      cfg = base_cfg
+      write_worktree_pointer!(task, worktree_path)
+
+      with_spawn_marker_stub(lambda do |spawn_task, kwargs|
+        # No commit, no exit-code file, empty tail: gate AND evidence refuse.
+        converted_result = Hive::ClaudeLauncher.maybe_complete_without_done_signal(
+          spawn_task, nil, "", kwargs[:log_label], kwargs.fetch(:completion_evidence)
+        )
+        converted_result || { status: :timeout,
+                              error_message: "claude stop hook did not signal completion" }
+      end) do
+        result = nil
+        _out = capture_io { result = Hive::Stages::Execute.run_pass(task, cfg, worktree_path) }
+
+        marker = Hive::Markers.current(task.state_file)
+        assert_equal :error, marker.name,
+                     "hollow completions must keep the strict implementer_failed attribution"
+        assert_equal "implementer_failed", marker.attrs["reason"]
+        assert_equal "timeout", marker.attrs["status"]
+        assert_equal "claude stop hook did not signal completion", marker.attrs["message"]
+      end
+    end
+  end
+
   private
 
   def base_cfg
@@ -160,4 +215,17 @@ class ExecuteTmuxEnvelopeTest < Minitest::Test
   ensure
     Hive::ClaudeLauncher.singleton_class.send(:define_method, :launch!, original) if original
   end
+
+  # Stub only Base's tmux-marker spawn wrapper; everything inside (evidence
+  # closure built by Execute) stays real so the fallback conversion path is
+  # exercised end-to-end against actual task-folder scratch files.
+  def with_spawn_marker_stub(simulate)
+    original = Hive::Stages::Base.singleton_class.instance_method(:spawn_claude_with_tmux_marker!)
+    Hive::Stages::Base.define_singleton_method(:spawn_claude_with_tmux_marker!) do |spawn_task, cfg, **kwargs|
+      simulate.call(spawn_task, kwargs)
+    end
+    yield
+  ensure
+    Hive::Stages::Base.singleton_class.send(:define_method, :spawn_claude_with_tmux_marker!, original) if original
+  end
 end
diff --git a/test/unit/stages/review/ci_fix_test.rb b/test/unit/stages/review/ci_fix_test.rb
index f94c81a..8f0ca3b 100644
--- a/test/unit/stages/review/ci_fix_test.rb
+++ b/test/unit/stages/review/ci_fix_test.rb
@@ -482,6 +482,94 @@ class CiFixTest < Minitest::Test
     assert_equal "CI command is empty after parsing", result.reason
   end
 
+  # --- Tolerant-completion seam (U4) ------------------------------------
+  # A clean-exited ci-fix agent whose Stop-hook signal was lost must flow
+  # back into the loop (which re-runs CI and lets the verdict decide) rather
+  # than burning the error path. Simulated through the REAL launcher gate:
+  # commit in the worktree + claude_exit_code=0 → evidence truthy.
+  def test_ci_fix_timeout_with_clean_exit_and_commit_flows_back_into_loop
+    with_tmp_dir do |dir|
+      task_folder = File.join(dir, ".hive-state", "stages", "6-review", "ci-fallback-task")
+      FileUtils.mkdir_p([ task_folder, File.join(task_folder, "reviews") ])
+      worktree = Dir.mktmpdir("ci-evidence-wt")
+      init_evidence_repo!(worktree)
+      ci = write_ci_script(dir, "echo failing >&2\nexit 1")
+      cfg = cfg_with(ci, "review" => { "ci" => { "max_attempts" => 2 } })
+      captured = {}
+
+      replacement = lambda do |spawn_task, _cfg, **kwargs|
+        captured[:kwargs] = kwargs
+        evidence = kwargs.fetch(:completion_evidence)
+        File.write(File.join(worktree, "fix.txt"), "ci fix applied\n")
+        git = ->(*args) { raise "git #{args.first} failed" unless system("git", "-C", worktree, *args, out: File::NULL, err: File::NULL) }
+        git.call("add", ".")
+        git.call("commit", "-m", "fix: ci")
+        File.write(Hive::ClaudeLauncher.exit_code_path(spawn_task), "0\n")
+        converted = Hive::ClaudeLauncher.maybe_complete_without_done_signal(
+          spawn_task, nil, "fixed it", kwargs[:log_label], evidence
+        )
+        converted || { status: :timeout, error_message: "claude stop hook did not signal completion" }
+      end
+
+      with_replaced_singleton_method(Hive::Stages::Base, :spawn_claude!, replacement) do
+        result = Hive::Stages::Review::CiFix.run!(
+          cfg: cfg,
+          ctx: make_ctx(worktree, task_folder)
+        )
+
+        assert_equal 2, result.attempts,
+                     "the loop must treat the clean-exited pass as complete and re-run CI"
+        assert_equal :stale, result.status,
+                     "exhausted attempts after a tolerated pass stay :stale, never a fix-agent error"
+        refute_match(/fix agent failed/, result.error_message.to_s)
+      end
+    end
+  end
+
+  def test_ci_fix_hollow_timeout_keeps_strict_error
+    with_tmp_dir do |dir|
+      task_folder = File.join(dir, ".hive-state", "stages", "6-review", "ci-strict-task")
+      FileUtils.mkdir_p([ task_folder, File.join(task_folder, "reviews") ])
+      worktree = Dir.mktmpdir("ci-strict-wt")
+      init_evidence_repo!(worktree)
+      ci = write_ci_script(dir, "echo failing >&2\nexit 1")
+      cfg = cfg_with(ci, "review" => { "ci" => { "max_attempts" => 2 } })
+
+      replacement = lambda do |spawn_task, _cfg, **kwargs|
+        evidence = kwargs.fetch(:completion_evidence)
+        # No exit-code file, no commit: generic gate AND evidence both fail.
+        converted = Hive::ClaudeLauncher.maybe_complete_without_done_signal(
+          spawn_task, nil, "", kwargs[:log_label], evidence
+        )
+        converted || { status: :timeout, error_message: "claude stop hook did not signal completion" }
+      end
+
+      with_replaced_singleton_method(Hive::Stages::Base, :spawn_claude!, replacement) do
+        result = Hive::Stages::Review::CiFix.run!(
+          cfg: cfg,
+          ctx: make_ctx(worktree, task_folder)
+        )
+
+        assert_equal :error, result.status
+        assert_equal "claude stop hook did not signal completion",
+                     result.error_message,
+                     "a hollow ci-fix run must keep the strict stop-hook timeout attribution"
+      end
+    end
+  end
+
+  private
+
+  def init_evidence_repo!(path)
+    run!("git", "-C", path, "init", "-b", "main", "--quiet")
+    run!("git", "-C", path, "config", "user.email", "t@example.com")
+    run!("git", "-C", path, "config", "user.name", "T")
+    run!("git", "-C", path, "config", "commit.gpgsign", "false")
+    File.write(File.join(path, "seed.txt"), "seed\n")
+    run!("git", "-C", path, "add", ".")
+    run!("git", "-C", path, "commit", "-m", "init", "--quiet")
+  end
+
   def test_run_ci_once_reports_pipe_launch_failure
     with_replaced_singleton_method(IO, :pipe, -> { raise "pipe exploded" }) do
       result = Hive::Stages::Review::CiFix.run_ci_once([ "ci" ], Dir.pwd, 1024, 1)
